org.apache.storm.eventhubs.bolt

## Class EventHubBolt

- java.lang.Object
- - org.apache.storm.topology.base.BaseComponent
  - - org.apache.storm.topology.base.BaseRichBolt
    - - org.apache.storm.eventhubs.bolt.EventHubBolt

- All Implemented Interfaces:
    Serializable, IBolt, IComponent, IRichBolt

      public class EventHubBolt
      extends BaseRichBolt

  A bolt that writes event message to EventHub.

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected EventHubBoltConfig` | `boltConfig`
    `protected OutputCollector` | `collector`
    `protected com.microsoft.azure.eventhubs.EventHubClient` | `ehClient`
    `protected com.microsoft.azure.eventhubs.PartitionSender` | `sender`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EventHubBolt(EventHubBoltConfig config)`
    `EventHubBolt(String connectionString, String entityPath)`
    `EventHubBolt(String userName, String password, String namespace, String entityPath, boolean partitionMode)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `cleanup()` Called when an IBolt is going to be shutdown.
    `void` | `declareOutputFields(OutputFieldsDeclarer declarer)` Declare the output schema for all the streams of this topology.
    `void` | `execute(Tuple tuple)` Process a single tuple of input.
    `void` | `prepare(Map<String,Object> config, TopologyContext context, OutputCollector collector)` Called when a task for this component is initialized within a worker on the cluster.

    - ### Methods inherited from class org.apache.storm.topology.base.BaseComponent

      `getComponentConfiguration`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.storm.topology.IComponent

      `getComponentConfiguration`

- - ### Field Detail

    - #### collector

          protected OutputCollector collector

    - #### sender

          protected com.microsoft.azure.eventhubs.PartitionSender sender

    - #### ehClient

          protected com.microsoft.azure.eventhubs.EventHubClient ehClient

    - #### boltConfig

          protected EventHubBoltConfig boltConfig

  - ### Constructor Detail

    - #### EventHubBolt

          public EventHubBolt(String connectionString,
                              String entityPath)

    - #### EventHubBolt

          public EventHubBolt(String userName,
                              String password,
                              String namespace,
                              String entityPath,
                              boolean partitionMode)

    - #### EventHubBolt

          public EventHubBolt(EventHubBoltConfig config)

  - ### Method Detail

    - #### prepare

          public void prepare(Map<String,Object> config,
                              TopologyContext context,
                              OutputCollector collector)

      Description copied from interface: `IBolt`

      Called when a task for this component is initialized within a worker on the cluster. It provides the bolt with the environment in which the bolt executes.

      This includes the:

      Parameters:
        `config` - The Storm configuration for this bolt. This is the configuration provided to the topology merged in with cluster configuration on this machine.
        `context` - This object can be used to get information about this task’s place within the topology, including the task id and component id of this task, input and output information, etc.
        `collector` - The collector is used to emit tuples from this bolt. Tuples can be emitted at any time, including the prepare and cleanup methods. The collector is thread-safe and should be saved as an instance variable of this bolt object.

    - #### execute

          public void execute(Tuple tuple)

      Description copied from interface: `IBolt`

      Process a single tuple of input. The Tuple object contains metadata on it about which component/stream/task it came from. The values of the Tuple can be accessed using Tuple#getValue. The IBolt does not have to process the Tuple immediately. It is perfectly fine to hang onto a tuple and process it later (for instance, to do an aggregation or join).

      Tuples should be emitted using the OutputCollector provided through the prepare method. It is required that all input tuples are acked or failed at some point using the OutputCollector. Otherwise, Storm will be unable to determine when tuples coming off the spouts have been completed.

      For the common case of acking an input tuple at the end of the execute method, see IBasicBolt which automates this.

      Parameters:
        `tuple` - The input tuple to be processed.

    - #### cleanup

          public void cleanup()

      Description copied from interface: `IBolt`

      Called when an IBolt is going to be shutdown. Storm will make a best-effort attempt to call this if the worker shutdown is orderly. The `Config.SUPERVISOR_WORKER_SHUTDOWN_SLEEP_SECS` setting controls how long orderly shutdown is allowed to take. There is no guarantee that cleanup will be called if shutdown is not orderly, or if the shutdown exceeds the time limit.

      The one context where cleanup is guaranteed to be called is when a topology is killed when running Storm in local mode.

      Specified by:
        `cleanup` in interface `IBolt`
      Overrides:
        `cleanup` in class `BaseRichBolt`

    - #### declareOutputFields

          public void declareOutputFields(OutputFieldsDeclarer declarer)

      Description copied from interface: `IComponent`

      Declare the output schema for all the streams of this topology.

      Parameters:
        `declarer` - this is used to declare output stream ids, output fields, and whether or not each output stream is a direct stream

Copyright © 2021 The Apache Software Foundation. All rights reserved.